package com.dgtly.system.mapper;

import java.util.List;
import com.dgtly.system.domain.SysUser;
import org.apache.ibatis.annotations.Param;

/**
 * 用户表 数据层
 * 
 * @author ruoyi
 */
public interface SysUserMapper
{
    /**
     * 根据条件分页查询用户列表
     * 
     * @param sysUser 用户信息
     * @return 用户信息集合信息
     */
    public List<SysUser> selectUserList(SysUser sysUser);

    /**
     * 根据条件分页查询未已配用户角色列表
     * 
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    public List<SysUser> selectAllocatedList(SysUser user);

    /**
     * 根据条件分页查询未分配用户角色列表
     * 
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    public List<SysUser> selectUnallocatedList(SysUser user);

    /**
     * 通过用户名查询用户
     * 
     * @param userName 用户名
     * @return 用户对象信息
     */
    public SysUser selectUserByLoginName(String userName);

    /**
     * 通过手机号码查询用户
     * 
     * @param phoneNumber 手机号码
     * @return 用户对象信息
     */
    public SysUser selectUserByPhoneNumber(String phoneNumber);

    /**
     * 通过邮箱查询用户
     * 
     * @param email 邮箱
     * @return 用户对象信息
     */
    public SysUser selectUserByEmail(String email);

    /**
     * 通过用户ID查询用户
     *
     * @param userId 用户ID
     * @return 用户对象信息
     */
    public SysUser selectUserById(Long userId);

    /**
     * 通过用户ID删除用户
     * 
     * @param userId 用户ID
     * @return 结果
     */
    public int deleteUserById(Long userId);

    /**
     * 批量删除用户信息
     * 
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteUserByIds(Long[] ids);

    /**
     * 修改用户信息
     * 
     * @param user 用户信息
     * @return 结果
     */
    public int updateUser(SysUser user);

    /**
     * 修改全公司的状态
     *
     * @param companyId 公司编号
     * @param status 人员状态：0正常 2删除
     * @return 结果
     */
    public int changeStatus(@Param("companyId") Long companyId,@Param("status")Integer status);

    /**
     * 新增用户信息
     * 
     * @param user 用户信息
     * @return 结果
     */
    public int insertUser(SysUser user);

    /**
     * 校验用户名称是否唯一
     * 
     * @param loginName 登录名称
     * @return 结果
     */
    public int checkLoginNameUnique(@Param("loginName") String loginName,@Param("companyId") Long companyId);

    /**
     * 校验手机号码是否唯一
     *
     * @param phonenumber 手机号码
     * @return 结果
     */
    public SysUser checkPhoneUnique(@Param("phonenumber") String phonenumber,@Param("companyId") Long companyId);

    /**
     * 校验email是否唯一
     *
     * @param email 用户邮箱
     * @return 结果
     */
    public SysUser checkEmailUnique(@Param("email")String email,@Param("companyId") Long companyId);

    /**
     * @Description: 查询已经排班的需要考勤的员工信息
     * @Param: [user]
     * @Return: java.util.List<com.dgtly.system.domain.SysUser>
     * @Author: koucx
     * @Date: 2019-11-01
    **/
    List<SysUser> needSignUser(SysUser user);

    /*
     * @Description: 根据优图ID查询系统用户信息
     * @Author: shangkai
     * @Date: 2020-1-13
     **/
    SysUser selectUserInfoByPersionId(@Param("persionId") String persionId);

    /**
     * 查询网格管理人员
     *
     * @param user 用户参数
     * @return 结果
     */
    public List<SysUser> selectGridPeople(SysUser user);

    /**
     * 查询普通人员
     *
     * @param user 用户参数
     * @return 结果
     */
    public List<SysUser> selectPeople(SysUser user);

    /**
     * 根据登录名模糊判断手机号或登录名称登录
     *
     * @param username 登录的用户名称 可能是手机号
     * @return 用户信息集合信息
     */
    public List<SysUser> selectUserByLoginNameOrPhone(String username);
}
